require("silo-script")
local version = 1

script.on_event(defines.events.on_player_created, function(event)
  local player = game.players[event.player_index]
  player.insert{name="iron-plate", count=8}
  player.insert{name="pistol", count=1}
  player.insert{name="firearm-magazine", count=10}
  player.insert{name="burner-mining-drill", count = 1}
  player.insert{name="stone-furnace", count = 1}
  player.force.chart(player.surface, {{player.position.x - 200, player.position.y - 200}, {player.position.x + 200, player.position.y + 200}})
  if (#game.players <= 1) then
    game.show_message_dialog{text = {"msg-intro"}}
  else
    player.print({"msg-intro"})
  end
  silo_script.gui_init(player)
end)

script.on_event(defines.events.on_player_respawned, function(event)
  local player = game.players[event.player_index]
  player.insert{name="pistol", count=1}
  player.insert{name="firearm-magazine", count=10}
end)

script.on_event(defines.events.on_gui_click, function(event)
  silo_script.on_gui_click(event)
end)

script.on_init(function()
  global.version = version
  silo_script.init()
end)

script.on_event(defines.events.on_rocket_launched, function(event)
  silo_script.on_rocket_launched(event)
end)

script.on_configuration_changed(function(event)
  if global.version ~= version then
    global.version = version
  end
  silo_script.on_configuration_changed(event)
end)

silo_script.add_remote_interface()


local announcements = {
   "(SERVER) Join us at discord.gg/HYCayGz",
   "(SERVER) Check our discord to vote for next map/mod!",
   "(SERVER) Server down? @distortions on discord!",
   "(SERVER) New players will have some restrictions on their permissions..."
}

local function show_announcement(event)
   global.last_announcement = global.last_announcement or 0
   global.announcement_delay = global.announcement_delay or 600
   
   if (game.tick / 60 - global.last_announcement > global.announcement_delay) then
      global.current_message = global.current_message or 1
      game.print(announcements[global.current_message])
      global.current_message = (global.current_message == #announcements) and 1 or global.current_message + 1
      global.last_announcement = game.tick / 60
   end
   
end

local function get_permgroup()
   global.last_trust_check = global.last_trust_check or 0
   global.trust_check_delay = global.trust_check_delay or 1
   global.player_probation_time = global.player_probation_time or 15
   
  if (game.tick / 60 - global.last_trust_check > global.trust_check_delay ) then

    global.trustedgroup = game.permissions.get_group("Trusted")
    global.admingroup = game.permissions.get_group("Admin")
    if ( global.trustedgroup == nil ) then
      game.permissions.create_group("Trusted")
    end
    if ( global.admingroup == nil ) then
      game.permissions.create_group("Admin" )
    end
    global.trustedgroup = game.permissions.get_group("Trusted")
    global.admingroup = game.permissions.get_group("Admin")

    for _, player in pairs(game.connected_players) do
      if (player.admin) then
        if (player.permission_group ~= nil ) then
        if(player.permission_group.name ~= "Admin") then
          global.admingroup.add_player(player)
        end
        end
        
      else
  
        if (player.online_time / 60 / 60 ) > global.player_probation_time then
        if (player.permission_group ~= nil ) then
          if(player.permission_group.name ~= "Trusted") then
            if ( global.trustedgroup.add_player(player) == true ) then
             player.print ( "(SERVER) You have now been playing long enough, that the new-user restrictions on your character have been lifted... Have fun, and be nice!" )
            end
          end
        end
        end
        
      end
  end
  
  global.last_trust_check = game.tick / 60
  end
end

script.on_event(defines.events.on_tick, function(event)
    show_announcement()
    get_permgroup()
end)

